{********************************************************************************}
{ Lesslib 1.3 (06-12-05) - Libreria para hacer juegos bajo ms-dos, en modo 13h   }
{ Copyright (C) 2004  Gorka Surez Garca                                        }
{                                                                                }
{ This library is free software; you can redistribute it and/or                  }
{ modify it under the terms of the GNU Lesser General Public                     }
{ License as published by the Free Software Foundation; either                   }
{ version 2.1 of the License, or (at your option) any later version.             }
{                                                                                }
{ This library is distributed in the hope that it will be useful,                }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of                 }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU              }
{ Lesser General Public License for more details.                                }
{                                                                                }
{ You should have received a copy of the GNU Lesser General Public               }
{ License along with this library; if not, write to the Free Software            }
{ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA      }
{                                                                                }
{--------------------------------------------------------------------------------}
{                                                                                }
{ Gua de versiones:                                                             }
{ + 1.3 (06-12-05): Aadida las rutinas para escribir texto en la pantalla,      }
{                   cargando una fuente primero. Y tambin se han aadido        }
{                   algunas funciones para cargar ficheros, y para controlar el  }
{                   tiempo.                                                      }
{                                                                                }
{ + 1.2 (30-11-05): Se ha reforzado la seguridad de algunas funciones y se han   }
{                   aadido nuevas funciones para mejorar las prestaciones de la }
{                   librera a la hora de copiar imagenes a pantalla.            }
{                                                                                }
{ + 1.1 (23-11-05): Se han corregido algunos bugs del modo texto de la librera. }
{   - Corregida la rutina MTxtBorrarPant, para que el cursor se ponga al inicio  }
{     del buffer de pantalla, para borrarla.                                     }
{   - Corregida la rutina MTxtPonCar, para que se pinte los caracteres con los   }
{     colores almacenados en MTxtAtr.                                            }
{                                                                                }
{ + 1.0 (01-02-04): Primera versin definitiva de la librera.                   }
{                                                                                }
{********************************************************************************}
unit Lesslib;
{$G+}
{********************************************************************************}
interface {parte publica}
{================================================================================}
uses crt;
{================================================================================}
const
   M13HMAXTAMBUF = 64000;

   FUENTE_ALTO  = 14;
   FUENTE_ANCHO = 7;
{================================================================================}
type
   dword = longint;

{--------------------------------------------------------------------------------}
   tPunto = record
      azul      : byte;
      verde     : byte;
      rojo      : byte;
      reservado : byte;
   end;

   tPaleta = array[0..255] of tPunto;
   tFPal   = file of tPaleta;

   BmpCab = record
      bfTipo           : word;  {Tipo del fichero -> BMP 0x4D42}
      bfTamanyo        : dword; {Tamao en Bytes de la estructura}
      bfReservado      : dword; {=0}
      bfDespazamiento  : dword; {Indica el desplacamiento desde la cabecera del
                                 fichero hasta la zona de datos}
      biTamanyo        : dword; {Tamao en bytes de la estructura}
      biAncho          : dword; {Ancho-X}
      biAlto           : dword; {Alto-Y}
      biPlanos         : word;  {=1}
      biProfundidad    : word;  {Bpp = 1, 4, 8, 16, 24, 32}
      biCompresion     : dword; {=BI_RGB}
      biTamImagen      : dword; {Tamao en Bytes de la imagen}
      biXPixelsMetro   : dword; {# de pixels x metro en el eje x}
      biYPixelsMetro   : dword; {# de pixels x metro en el eje y}
      biColUsados      : dword; {# de colores usados}
      biColImportantes : dword; {# de colores importantes}
   end;

   tBuffer = array[1..64000] of byte;

   tImg = ^byte;
   tImagen = record
      ancho : dword;
      alto  : dword;
      img   : tImg;
   end;

   tFuente = record
      cclave : byte;
      imagen : tImagen;
   end;

{--------------------------------------------------------------------------------}
   tRect = record
         x, y, w, h: word;
      end;

{--------------------------------------------------------------------------------}
   tRaton = record
      x, y: word;
      bi, bc, bd: boolean;
      xr, yr: word;
      vx, vy, maxvel: word;
   end;

{================================================================================}
{Las rutinas graficas para el modo de texto                                      }
{================================================================================}
procedure MTxt80;
procedure MTxt40;

procedure MTxtPonCar   (car: char);
procedure MTxtPonCad   (cad: string);
procedure MTxtIraXY    (x, y: byte);
procedure MTxtColTexto (col: byte);
procedure MTxtColFondo (col: byte);

procedure MTxtBorrarPant;
procedure MTxtOcultarCursor;
procedure MTxtMostrarCursor;
procedure MTxtCursorGrande;

{================================================================================}
{Las rutinas para el uso del raton                                               }
{================================================================================}
function  RatonActivar : integer;
procedure RatonMostrar;
procedure RatonOcultar;
procedure RatonEstado      (var raton: tRaton);
procedure RatonMover       (x, y: word);
procedure RatonXYRel       (var raton: tRaton);
procedure RatonPonVel      (var raton: tRaton);
procedure RatonDarVel      (var raton: tRaton);
procedure RatonVelMuestreo (velmues: word);
procedure RatonPonPagVideo (pagvid: byte);
function  RatonDarPagVideo : byte;
procedure RatonLimitar     (x1, y1, x2, y2: word);
function  RatonEstaEn      (raton: tRaton; x, y, w, h: word): boolean;
function  RatonEstaEn2     (raton: tRaton; region: tRect): boolean;

{================================================================================}
{Las rutinas graficas para el modo 13h                                           }
{================================================================================}
function  M13hActivar: boolean;
procedure M13hDesactivar;
procedure M13hActualizarPantalla;

procedure M13hPixelPoner          (x, y: word; color: byte);
function  M13hPixelCoger          (x, y: word): byte;

procedure M13hPaleta24a18         (var paleta: tPaleta);
procedure M13hPaleta18a24         (var paleta: tPaleta);
procedure M13hPaletaCargar        (paleta: tPaleta);
procedure M13hPaletaSalvar        (var paleta: tPaleta);
procedure M13hPaletaPonerColor    (posicion: byte; color: tPunto);
procedure M13hPaletaCogerColor    (var color: tPunto; posicion: byte);
procedure M13hPaletaCargarFichero (ruta: string; var paleta: tPaleta);
procedure M13hPaletaSalvarFichero (ruta: string; paleta: tPaleta);

procedure M13hImagenCargar        (ruta: string; var imagen: tImagen);
procedure M13hImagenSalvar        (ruta: string; imagen: tImagen);
procedure M13hImagenCargarFichero (ruta: string; var imagen: tImagen; var paleta: tPaleta);
procedure M13hImagenSalvarFichero (ruta: string; imagen: tImagen; paleta: tPaleta);
procedure M13hImagenPegar         (x, y: word; imagen: tImagen);
procedure M13hImagenPegar2        (x, y: word; imagen: tImagen; colorclave: byte);
procedure M13hImagenPegar3        (x, y, ancho, alto: word; imagen: tImagen);
procedure M13hImagenPegar4        (x, y, ancho, alto: word; imagen: tImagen; colorclave: byte);
procedure M13hImagenPegar5        (x, y, ancho, alto, xi, yi: word; imagen: tImagen);
procedure M13hImagenPegar6        (x, y, ancho, alto, xi, yi: word; imagen: tImagen; colorclave: byte);
procedure M13hImagenPegar7        (x, y: word; orig: tRect; imagen: tImagen);
procedure M13hImagenPegar8        (x, y: word; orig: tRect; imagen: tImagen; colorclave: byte);
procedure M13hImagenPegarMascara  (x, y, ancho, alto, xi, yi: word; imagen: tImagen; cclave, cmascara: byte);
procedure M13hImagenCopiar        (x, y, ancho, alto: word; var imagen: tImagen);
procedure M13hImagenCopiarImagen  (x, y, ancho, alto: word; var imagen, imgorig: tImagen);

procedure M13hBorrarPantalla      (color: byte);
procedure M13hLimpiarImagen       (var imagen: tImagen; color: byte);
procedure M13hCrearImagen         (ancho, alto: word; var imagen: tImagen);
procedure M13hBorrarImagen        (var imagen: tImagen);
procedure M13hImagenPonPixel      (x, y: word; var imagen: tImagen; color: byte);
function  M13hImagenDarPixel      (x, y: word; var imagen: tImagen): byte;

{================================================================================}
{Rutinas auxiliares para tratar temas variados                                   }
{================================================================================}
function DarTecla: integer;
function DarTiempo: dword;

{================================================================================}
{Rutinas para el manejo de las fuentes y el texto                                }
{================================================================================}
procedure FuenteCargar      (ruta: string; var fuente: tFuente);
procedure FuenteDescargar   (var fuente: tFuente);
procedure FuentePegarLetra  (car: char; x, y: word; color: byte; fuente: tFuente);
procedure FuentePegarLetra2 (car: char; x, y: word; color: byte; fuente: tFuente);
procedure FuenteEscribir    (cadena: string; x, y: word; color: byte; fuente: tFuente);
procedure FuenteEscribir2   (cadena: string; x, y: word; color: byte; fuente: tFuente);

{********************************************************************************}
implementation {parte privada}
{================================================================================}
var
   M13hBuffer: ^tBuffer;
   MTxtPos, MTxtAtr, ModoTxt: byte;
{================================================================================}
{Las rutinas graficas para el modo de texto                                      }
{================================================================================}
procedure MTxt80;
begin
   asm
      mov   ax, 0003h
      int   10h
   end;

   ModoTxt := 80;
   MTxtPos := 0;
end;
{--------------------------------------------------------------------------------}
procedure MTxt40;
begin
   asm
      mov   ax, 0001h
      int   10h
   end;

   ModoTxt := 40;
   MTxtPos := 0;
end;
{--------------------------------------------------------------------------------}
procedure MTxtPonCar (car: char);
begin
   mem[$B800:MTxtPos]   := Ord(car);
   mem[$B800:MTxtPos+1] := MTxtAtr;
   MTxtPos := MTxtPos + 2;
end;
{--------------------------------------------------------------------------------}
procedure MTxtPonCad (cad: string);
var
   i: integer;
begin
   for i := 1 to length(cad) do
    begin
      MTxtPonCar(cad[i]);
    end;
end;
{--------------------------------------------------------------------------------}
procedure MTxtIraXY (x, y: byte);
begin
   if (ModoTxt = 80) then
      MTxtPos := y * 160 + x * 2
   else
      MTxtPos := y * 80 + x * 2;
end;
{--------------------------------------------------------------------------------}
procedure MTxtColTexto (col: byte);
begin
   MTxtAtr := MTxtAtr and $F0;
   MTxtAtr := MTxtAtr or col;
end;
{--------------------------------------------------------------------------------}
procedure MTxtColFondo (col: byte);
begin
   MTxtAtr := MTxtAtr and $0F;
   col     := col * 16;
   MTxtAtr := MTxtAtr or col;
end;
{--------------------------------------------------------------------------------}
procedure MTxtBorrarPant;
var
   i, t: integer;
begin
   MTxtPos := 0;

   if (ModoTxt = 80) then
      t := 2000
   else
      t := 1000;

   for i := 1 to t do
    begin
      MTxtPonCar(' ');
    end;
end;
{--------------------------------------------------------------------------------}
procedure MTxtOcultarCursor;
begin
   asm
      mov   ch, 01h
      mov   cl, 00h
      mov   ah, 01h
      int   10h
   end;
end;
{--------------------------------------------------------------------------------}
procedure MTxtMostrarCursor;
begin
   asm
      mov   ch, 06h
      mov   cl, 07h
      mov   ah, 01h
      int   10h
   end;
end;
{--------------------------------------------------------------------------------}
procedure MTxtCursorGrande;
begin
   asm
      mov   ch, 01h
      mov   cl, 07h
      mov   ah, 01h
      int   10h
   end;
end;

{================================================================================}
{Las rutinas para el manejo del raton                                            }
{================================================================================}
{Comprueba que haya algun raton instalado, devolviendo el numero de botones de
 este. Si devuelve 0, quiere decir que no hay ningun raton instalado.}
function  RatonActivar : integer;
var
   estado, botones: integer;
begin
   asm
      xor   ax, ax
      int   33h

      mov   estado, ax
      mov   botones, bx
   end;

   if (estado <> 0) then
      RatonActivar := botones
   else
      RatonActivar := 0;
end;
{--------------------------------------------------------------------------------}
procedure RatonMostrar;
begin
   asm
      mov   ax, 01h
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
procedure RatonOcultar;
begin
   asm
      mov   ax, 02h
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
procedure RatonEstado (var raton: tRaton);
var
   x, y, botones: word;
begin
   asm
      mov   ax, 03h
      int   33h

      mov   x, cx
      mov   y, dx
      mov   botones, bx
   end;

   raton.x  := x;
   raton.y  := y;
   raton.bi := (botones and 1) <> 0;
   raton.bc := (botones and 4) <> 0;
   raton.bd := (botones and 2) <> 0;
end;
{--------------------------------------------------------------------------------}
{Situa el cursor en las coordenadas indicadas}
procedure RatonMover (x, y: word);
begin
   asm
      mov   ax, 04h
      mov   cx, x
      mov   dx, y
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
procedure RatonXYRel (var raton: tRaton);
var
   xr, yr: word;
begin
   asm
      mov   ax, 0Bh
      int   33h

      mov   xr, cx
      mov   yr, dx
   end;

   raton.xr := xr;
   raton.yr := yr;
end;
{--------------------------------------------------------------------------------}
procedure RatonPonVel (var raton: tRaton);
var
   vx, vy, maxvel: word;
begin
   vx     := raton.vx;
   vy     := raton.vy;
   maxvel := raton.maxvel;

   asm
      mov   ax, 1Ah
      mov   bx, vx
      mov   cx, vy
      mov   dx, maxvel
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
procedure RatonDarVel (var raton: tRaton);
var
   vx, vy, maxvel: word;
begin
   asm
      mov   ax, 1Bh
      int   33h

      mov   vx, bx
      mov   vy, cx
      mov   maxvel, dx
   end;

   raton.vx     := vx;
   raton.vy     := vy;
   raton.maxvel := maxvel;
end;
{--------------------------------------------------------------------------------}
procedure RatonVelMuestreo (velmues: word);
begin
   asm
      mov   ax, 1Ch
      mov   bx, velmues
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
procedure RatonPonPagVideo (pagvid: byte);
begin
   asm
      mov   ax, 1Dh
      xor   bx, bx
      mov   bl, pagvid
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
function  RatonDarPagVideo : byte;
var
   pagvid: byte;
begin
   asm
      mov   ax, 1Eh
      int   33h

      mov   pagvid, bl
   end;

   RatonDarPagVideo := pagvid;
end;
{--------------------------------------------------------------------------------}
procedure RatonLimitar (x1, y1, x2, y2: word);
begin
   asm
      mov   ax, 7
      mov   cx, x1
      mov   dx, x2
      int   33h

      mov   ax, 8
      mov   cx, y1
      mov   dx, y2
      int   33h
   end;
end;
{--------------------------------------------------------------------------------}
function RatonEstaEn (raton: tRaton; x, y, w, h: word): boolean;
begin
   if (x <= raton.x) and (raton.x < (x + w)) and
      (y <= raton.y) and (raton.y < (y + h)) then
      RatonEstaEn := true
   else
      RatonEstaEn := false;
end;
{--------------------------------------------------------------------------------}
function RatonEstaEn2 (raton: tRaton; region: tRect): boolean;
begin
   if (region.x <= raton.x) and (raton.x < (region.x + region.w)) and
      (region.y <= raton.y) and (raton.y < (region.y + region.h)) then
      RatonEstaEn2 := true
   else
      RatonEstaEn2 := false;
end;

{================================================================================}
{Las rutinas graficas para el modo 13h                                           }
{================================================================================}
function M13hActivar: boolean;
begin
   asm
      mov ax, 0013h
      int 10h
   end;

   M13hBuffer := nil;
   new(M13hBuffer);
   if M13hBuffer <> nil then
    begin
      M13hActivar := true;
      M13hBorrarPantalla(0);
    end
   else
    begin
      M13hActivar := false;
      M13hDesactivar;
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hDesactivar;
begin
   asm
      mov ax, 0003h
      int 10h
   end;

   dispose(M13hBuffer);
end;
{--------------------------------------------------------------------------------}
procedure M13hActualizarPantalla;
var
   i: word;
begin
   asm
      mov dx, 03DAh
@a:   in  al, dx
      and al, 08h
      jnz @a
@b:   in  al, dx
      and al, 88h
      jz  @b
   end;

   for i := 1 to 64000 do
      mem[$A000:(i-1)] := M13hBuffer^[i];
end;
{--------------------------------------------------------------------------------}
procedure M13hPixelPoner (x, y: word; color: byte);
var
   pos: dword;
begin
   pos := y*320+x+1;

   if (0 < pos) and (pos <= M13HMAXTAMBUF) then
      M13hBuffer^[pos] := color;
end;
{--------------------------------------------------------------------------------}
function  M13hPixelCoger (x, y: word): byte;
var
   pos: dword;
begin
   pos := y*320+x+1;

   if (0 < pos) and (pos <= M13HMAXTAMBUF) then
      M13hPixelCoger := M13hBuffer^[pos]
   else
      M13hPixelCoger := 0;
end;
{--------------------------------------------------------------------------------}
procedure M13hPaleta24a18 (var paleta: tPaleta);
var
   i: integer;
begin
   for i := 0 to 255 do
    begin
      paleta[i].rojo  := paleta[i].rojo  div 4;
      paleta[i].verde := paleta[i].verde div 4;
      paleta[i].azul  := paleta[i].azul  div 4;
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hPaleta18a24 (var paleta: tPaleta);
var
   i: integer;
begin
   for i := 0 to 255 do
    begin
      paleta[i].rojo  := paleta[i].rojo  * 4;
      paleta[i].verde := paleta[i].verde * 4;
      paleta[i].azul  := paleta[i].azul  * 4;
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hPaletaPonerColor (posicion: byte; color: tPunto);
var
   r, g, b: byte;
begin
   r := color.rojo;
   g := color.verde;
   b := color.azul;

   asm
      xor bx, bx
      mov bl, posicion
      mov dh, r
      mov ch, g
      mov cl, b
      mov ax, 1010h
      int 10h
   end;
end;
{--------------------------------------------------------------------------------}
procedure M13hPaletaCogerColor (var color: tPunto; posicion: byte);
var
   r, g, b: byte;
begin
   asm
      xor bx, bx
      mov bl, posicion
      mov ax, 1015h
      int 10h
      mov r, dh
      mov g, ch
      mov b, cl
   end;

   color.rojo  := r;
   color.verde := g;
   color.azul  := b;
end;
{--------------------------------------------------------------------------------}
procedure M13hPaletaCargar (paleta: tPaleta);
var
   i: integer;
begin
   for i := 0 to 255 do
      M13hPaletaPonerColor(i, paleta[i]);
end;
{--------------------------------------------------------------------------------}
procedure M13hPaletaSalvar (var paleta: tPaleta);
var
   i: integer;
begin
   for i := 0 to 255 do
      M13hPaletaCogerColor(paleta[i], i);
end;
{--------------------------------------------------------------------------------}
procedure M13hPaletaCargarFichero (ruta: string; var paleta: tPaleta);
var
   f: tFPal;
begin
   assign(f, ruta);
   {$I-}
   reset(f);
   {$I+}

   if IOResult = 0 then
    begin
      read(f, paleta);

      close(f);
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hPaletaSalvarFichero (ruta: string; paleta: tPaleta);
var
   f: tFPal;
begin
   assign(f, ruta);
   {$I-}
   rewrite(f);
   {$I+}

   if IOResult = 0 then
    begin
      write(f, paleta);

      close(f);
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenCargar (ruta: string; var imagen: tImagen);
var
   f: file;
   f2: file of byte;
   y, x: integer;
   cab: BmpCab;
   color: byte;
   num: word;
   imgaux: tImagen;
   paleta: tPaleta;
begin
   assign(f, ruta);
   {$I-}
   reset(f, 1);
   {$I+}

   imagen.ancho := 0;
   imagen.alto  := 0;
   imagen.img   := nil;

   if IOResult = 0 then {blockread(f, buf, tam)}
    begin
      {Cabecera}
      blockread(f, cab, sizeof(BmpCab), num);

      if (cab.bfTipo = $4D42) and (cab.biProfundidad = 8) then
       begin
         M13hCrearImagen(cab.biancho, cab.bialto, imagen);
         M13hCrearImagen(cab.biancho, cab.bialto, imgaux);

         {Paleta}
         blockread(f, paleta, sizeof(tPaleta), num);

         {Imagen}
         {seek(f, 1078);}
         for y := 0 to (imagen.alto-1) do
            for x := 0 to (imagen.ancho-1) do
             begin
               blockread(f, color, sizeof(byte), num);
               M13hImagenPonPixel(x, y, imgaux, color);
             end;

         for y := (imagen.alto-1) downto 0 do
            for x := 0 to (imagen.ancho-1) do
             begin
               color := M13hImagenDarPixel(x, y, imgaux);
               M13hImagenPonPixel(x, ((imagen.alto-1)-y), imagen, color);
             end;

         M13hBorrarImagen(imgaux);
       end;

      close(f);
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenSalvar (ruta: string; imagen: tImagen);
var
   f: file;
   y, x, tam: integer;
   cab: BmpCab;
   color: byte;
   num: word;
   imgaux: tImagen;
   paleta: tPaleta;
begin
   assign(f, ruta);
   {$I-}
   rewrite(f, 1);
   {$I+}

   if IOResult = 0 then {blockwrite(f, buf, tam)}
    begin
      {Cabecera}
      tam := (imagen.ancho * imagen.alto) + 1078;
      cab.bfTipo           := $4D42; {Tipo del fichero -> BMP 0x4D42}
      cab.bfTamanyo        := tam;   {Tamao en Bytes de la estructura}
      cab.bfReservado      := 0;     {=0}
      cab.bfDespazamiento  := 1078;  {Indica el desplacamiento desde la cabecera del
                                      fichero hasta la zona de datos}

      tam := (imagen.ancho * imagen.alto);
      cab.biTamanyo        := 40;           {Tamao en bytes de la estructura}
      cab.biAncho          := imagen.ancho; {Ancho-X}
      cab.biAlto           := imagen.alto;  {Alto-Y}
      cab.biPlanos         := 1;            {=1}
      cab.biProfundidad    := 8;            {Bpp = 1, 4, 8, 16, 24, 32}
      cab.biCompresion     := 0;            {=BI_RGB}
      cab.biTamImagen      := tam;          {Tamao en Bytes de la imagen}
      cab.biXPixelsMetro   := 0;            {# de pixels x metro en el eje x}
      cab.biYPixelsMetro   := 0;            {# de pixels x metro en el eje y}
      cab.biColUsados      := 0;            {# de colores usados}
      cab.biColImportantes := 0;            {# de colores importantes}

      blockwrite(f, cab, sizeof(BmpCab), num);


      {Paleta}
      M13hPaletaSalvar(paleta);
      blockwrite(f, paleta, sizeof(tPaleta), num);


      {Imagen}
      M13hCrearImagen(cab.biancho, cab.bialto, imgaux);
      for y := (imagen.alto-1) downto 0 do
         for x := 0 to (imagen.ancho-1) do
          begin
            color := M13hImagenDarPixel(x, y, imagen);
            M13hImagenPonPixel(x, ((imagen.alto-1)-y), imgaux, color);
          end;

      for y := 0 to (imagen.alto-1) do
         for x := 0 to (imagen.ancho-1) do
          begin
            color := M13hImagenDarPixel(x, y, imgaux);
            blockwrite(f, color, sizeof(byte), num);
          end;

      M13hBorrarImagen(imgaux);

      close(f);
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenCargarFichero (ruta: string; var imagen: tImagen; var paleta: tPaleta);
var
   f: file;
   f2: file of byte;
   y, x: integer;
   cab: BmpCab;
   color: byte;
   num: word;
   imgaux: tImagen;
begin
   assign(f, ruta);
   {$I-}
   reset(f, 1);
   {$I+}

   imagen.ancho := 0;
   imagen.alto  := 0;
   imagen.img   := nil;

   if IOResult = 0 then {blockread(f, buf, tam)}
    begin
      {Cabecera}
      blockread(f, cab, sizeof(BmpCab), num);

      if (cab.bfTipo = $4D42) and (cab.biProfundidad = 8) then
       begin
         M13hCrearImagen(cab.biancho, cab.bialto, imagen);
         M13hCrearImagen(cab.biancho, cab.bialto, imgaux);

         {Paleta}
         blockread(f, paleta, sizeof(tPaleta), num);

         {Imagen}
         {seek(f, 1078);}
         for y := 0 to (imagen.alto-1) do
            for x := 0 to (imagen.ancho-1) do
             begin
               blockread(f, color, sizeof(byte), num);
               M13hImagenPonPixel(x, y, imgaux, color);
             end;

         for y := (imagen.alto-1) downto 0 do
            for x := 0 to (imagen.ancho-1) do
             begin
               color := M13hImagenDarPixel(x, y, imgaux);
               M13hImagenPonPixel(x, ((imagen.alto-1)-y), imagen, color);
             end;

         M13hBorrarImagen(imgaux);
       end;

      close(f);
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenSalvarFichero (ruta: string; imagen: tImagen; paleta: tPaleta);
var
   f: file;
   y, x, tam: integer;
   cab: BmpCab;
   color: byte;
   num: word;
   imgaux: tImagen;
begin
   assign(f, ruta);
   {$I-}
   rewrite(f, 1);
   {$I+}

   if IOResult = 0 then {blockwrite(f, buf, tam)}
    begin
      {Cabecera}
      tam := (imagen.ancho * imagen.alto) + 1078;
      cab.bfTipo           := $4D42; {Tipo del fichero -> BMP 0x4D42}
      cab.bfTamanyo        := tam;   {Tamao en Bytes de la estructura}
      cab.bfReservado      := 0;     {=0}
      cab.bfDespazamiento  := 1078;  {Indica el desplacamiento desde la cabecera del
                                      fichero hasta la zona de datos}

      tam := (imagen.ancho * imagen.alto);
      cab.biTamanyo        := 40;           {Tamao en bytes de la estructura}
      cab.biAncho          := imagen.ancho; {Ancho-X}
      cab.biAlto           := imagen.alto;  {Alto-Y}
      cab.biPlanos         := 1;            {=1}
      cab.biProfundidad    := 8;            {Bpp = 1, 4, 8, 16, 24, 32}
      cab.biCompresion     := 0;            {=BI_RGB}
      cab.biTamImagen      := tam;          {Tamao en Bytes de la imagen}
      cab.biXPixelsMetro   := 0;            {# de pixels x metro en el eje x}
      cab.biYPixelsMetro   := 0;            {# de pixels x metro en el eje y}
      cab.biColUsados      := 0;            {# de colores usados}
      cab.biColImportantes := 0;            {# de colores importantes}

      blockwrite(f, cab, sizeof(BmpCab), num);


      {Paleta}
      blockwrite(f, paleta, sizeof(tPaleta), num);


      {Imagen}
      M13hCrearImagen(cab.biancho, cab.bialto, imgaux);
      for y := (imagen.alto-1) downto 0 do
         for x := 0 to (imagen.ancho-1) do
          begin
            color := M13hImagenDarPixel(x, y, imagen);
            M13hImagenPonPixel(x, ((imagen.alto-1)-y), imgaux, color);
          end;

      for y := 0 to (imagen.alto-1) do
         for x := 0 to (imagen.ancho-1) do
          begin
            color := M13hImagenDarPixel(x, y, imgaux);
            blockwrite(f, color, sizeof(byte), num);
          end;

      M13hBorrarImagen(imgaux);

      close(f);
    end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar (x, y: word; imagen: tImagen);
var
   f, c, pos: dword;
   color: byte;
begin
   for f := 0 to (imagen.alto-1) do
      for c := 0 to (imagen.ancho-1) do
       begin
         color := M13hImagenDarPixel(c, f, imagen);
         pos := (y+f)*320+(x+c) + 1;

         if (0 < pos) and (pos <= M13HMAXTAMBUF) then
            M13hBuffer^[pos] := color;
       end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar2 (x, y: word; imagen: tImagen; colorclave: byte);
var
   f, c, pos: dword;
   color: byte;
begin
   for f := 0 to (imagen.alto-1) do
      for c := 0 to (imagen.ancho-1) do
       begin
         color := M13hImagenDarPixel(c, f, imagen);
         if color <> colorclave then
          begin
            pos := (y+f)*320+(x+c) + 1;

            if (0 < pos) and (pos <= M13HMAXTAMBUF) then
               M13hBuffer^[pos] := color;
          end;
       end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar3 (x, y, ancho, alto: word; imagen: tImagen);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= alto) and (imagen.ancho >= ancho) then
      for f := 0 to (alto-1) do
         for c := 0 to (ancho-1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            pos := (y+f)*320+(x+c) + 1;

            if (0 < pos) and (pos <= M13HMAXTAMBUF) then
               M13hBuffer^[pos] := color;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar4 (x, y, ancho, alto: word; imagen: tImagen; colorclave: byte);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= alto) and (imagen.ancho >= ancho) then
      for f := 0 to (alto-1) do
         for c := 0 to (ancho-1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            if color <> colorclave then
             begin
               pos := (y+f)*320+(x+c) + 1;

               if (0 < pos) and (pos <= M13HMAXTAMBUF) then
                  M13hBuffer^[pos] := color;
             end;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar5 (x, y, ancho, alto, xi, yi: word; imagen: tImagen);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= (alto + yi)) and (imagen.ancho >= (ancho + xi)) then
      for f := yi to (alto+yi-1) do
         for c := xi to (ancho+xi-1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            pos := (y+f-yi)*320+(x+c-xi) + 1;

            if (0 < pos) and (pos <= M13HMAXTAMBUF) then
               M13hBuffer^[pos] := color;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar6 (x, y, ancho, alto, xi, yi: word; imagen: tImagen; colorclave: byte);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= (alto + yi)) and (imagen.ancho >= (ancho + xi)) then
      for f := yi to (alto+yi-1) do
         for c := xi to (ancho+xi-1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            if color <> colorclave then
             begin
               pos := (y+f-yi)*320+(x+c-xi) + 1;

               if (0 < pos) and (pos <= M13HMAXTAMBUF) then
                  M13hBuffer^[pos] := color;
             end;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar7 (x, y: word; orig: tRect; imagen: tImagen);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= (orig.h + orig.y)) and (imagen.ancho >= (orig.w + orig.x)) then
      for f := orig.y to (orig.h + orig.y - 1) do
         for c := orig.x to (orig.w + orig.x - 1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            pos := (y + f - orig.y) * 320 + (x + c - orig.x) + 1;

            if (0 < pos) and (pos <= M13HMAXTAMBUF) then
               M13hBuffer^[pos] := color;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegar8 (x, y: word; orig: tRect; imagen: tImagen; colorclave: byte);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= (orig.h + orig.y)) and (imagen.ancho >= (orig.w + orig.x)) then
      for f := orig.y to (orig.h + orig.y - 1) do
         for c := orig.x to (orig.w + orig.x - 1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            if color <> colorclave then
             begin
               pos := (y + f - orig.y) * 320 + (x + c - orig.x) + 1;

               if (0 < pos) and (pos <= M13HMAXTAMBUF) then
                  M13hBuffer^[pos] := color;
             end;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPegarMascara (x, y, ancho, alto, xi, yi: word; imagen: tImagen; cclave, cmascara: byte);
var
   f, c, pos: dword;
   color: byte;
begin
   if (imagen.alto >= (alto + yi)) and (imagen.ancho >= (ancho + xi)) then
      for f := yi to (alto+yi-1) do
         for c := xi to (ancho+xi-1) do
          begin
            color := M13hImagenDarPixel(c, f, imagen);
            if color <> cclave then
             begin
               pos := (y+f-yi)*320+(x+c-xi) + 1;

               if (0 < pos) and (pos <= M13HMAXTAMBUF) then
                  M13hBuffer^[pos] := cmascara;
             end;
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenCopiar (x, y, ancho, alto: word; var imagen: tImagen);
var
   f, c, pos: dword;
begin
   if (imagen.alto >= alto) and (imagen.ancho >= ancho) then
      for f := 0 to (alto-1) do
         for c := 0 to (ancho-1) do
          begin
            pos := (y+f)*320+(x+c) + 1;

            if (0 < pos) and (pos <= M13HMAXTAMBUF) then
               M13hImagenPonPixel(c, f, imagen, M13hBuffer^[pos])
            else
               M13hImagenPonPixel(c, f, imagen, 0);
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenCopiarImagen (x, y, ancho, alto: word; var imagen, imgorig: tImagen);
var
   f, c: dword;
   color: byte;
begin
   if (imagen.alto >= alto) and (imagen.ancho >= ancho) then
      for f := 0 to (alto-1) do
         for c := 0 to (ancho-1) do
          begin
            color := M13hImagenDarPixel(x+c, y+f, imgorig);
            M13hImagenPonPixel(c, f, imagen, color);
          end;
end;
{--------------------------------------------------------------------------------}
procedure M13hBorrarPantalla (color: byte);
var
   i, tam: word;
begin
   tam := M13HMAXTAMBUF;
   for i := 1 to tam do
      M13hBuffer^[i] := color;
end;
{--------------------------------------------------------------------------------}
procedure M13hLimpiarImagen (var imagen: tImagen; color: byte);
var
   f, c, pos: dword;
begin
   for f := 0 to (imagen.alto-1) do
      for c := 0 to (imagen.ancho-1) do
       begin
         M13hImagenPonPixel(c, f, imagen, color);
       end;
end;
{--------------------------------------------------------------------------------}
procedure M13hCrearImagen (ancho, alto: word; var imagen: tImagen);
begin
   imagen.ancho := ancho;
   imagen.alto  := alto;

   getmem(imagen.img, ancho*alto);
end;
{--------------------------------------------------------------------------------}
procedure M13hBorrarImagen (var imagen: tImagen);
begin
   imagen.ancho := 0;
   imagen.alto  := 0;

   freemem(imagen.img, imagen.ancho*imagen.alto);
end;
{--------------------------------------------------------------------------------}
procedure M13hImagenPonPixel (x, y: word; var imagen: tImagen; color: byte);
var
   pos, segm, offs: word;
begin
   segm := seg(imagen.img^);
   offs := ofs(imagen.img^);
   pos := y * imagen.ancho + x;

   if (0 <= pos) and (pos < (imagen.ancho * imagen.alto)) then
      asm
         mov es, segm
         mov si, offs
         mov al, color
         mov bx, pos
         mov es:[si+bx], al
      end;
end;
{--------------------------------------------------------------------------------}
function M13hImagenDarPixel (x, y: word; var imagen: tImagen): byte;
var
   pos, segm, offs: word;
   color: byte;
begin
   segm := seg(imagen.img^);
   offs := ofs(imagen.img^);
   pos := y * imagen.ancho + x;

   if (0 <= pos) and (pos < (imagen.ancho * imagen.alto)) then
      asm
         mov es, segm
         mov si, offs
         mov bx, pos
         mov al, es:[si+bx]
         mov color, al
      end
   else
      color := 0;

   M13hImagenDarPixel := color;
end;

{================================================================================}
{Las rutinas para el uso de temas del teclado                                    }
{================================================================================}
function DarTecla: integer;
var
   tecla: integer;
begin
   tecla := 0;

   if keypressed then
    begin
      tecla := ord(readkey);
      if tecla = 0 then
         tecla := ord(readkey);
    end;

   DarTecla := tecla;
end;
{--------------------------------------------------------------------------------}
function DarTiempo: dword;
var
   hp, lp: word;
begin
   asm
      mov ah, 00h
      int 1Ah
      mov hp, cx
      mov lp, dx
   end;

   DarTiempo := trunc(((hp * $10000) + lp) * 1000 / 18.2);
end;

{================================================================================}
{Rutinas para el manejo de las fuentes y el texto                                }
{================================================================================}
procedure FuenteCargar (ruta: string; var fuente: tFuente);
begin
   M13hImagenCargar(ruta, fuente.imagen);
   fuente.cclave := M13hImagenDarPixel(0, 0, fuente.imagen);
end;
{--------------------------------------------------------------------------------}
procedure FuenteDescargar (var fuente: tFuente);
begin
   fuente.cclave := 0;
   M13hBorrarImagen(fuente.imagen);
end;
{--------------------------------------------------------------------------------}
procedure FuentePegarLetra (car: char; x, y: word; color: byte; fuente: tFuente);
var
   xi, yi: word;
begin
   case car of
      'A'..'Z':
         begin
            xi := FUENTE_ANCHO * (ord(car) - ord('A'));
            yi := 0;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := 0;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := 0;
         end;
      ' ':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := 0;
         end;
      'a'..'z':
         begin
            xi := FUENTE_ANCHO * (ord(car) - ord('a'));
            yi := FUENTE_ALTO;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := FUENTE_ALTO;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := FUENTE_ALTO;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := FUENTE_ALTO;
         end;
      '@':
         begin
            xi := FUENTE_ANCHO * 29;
            yi := FUENTE_ALTO;
         end;
      '0'..'9':
         begin
            xi := FUENTE_ANCHO * (ord(car) - ord('0'));
            yi := FUENTE_ALTO * 2;
         end;
      '<':
         begin
            xi := FUENTE_ANCHO * 10;
            yi := FUENTE_ALTO * 2;
         end;
      '>':
         begin
            xi := FUENTE_ANCHO * 11;
            yi := FUENTE_ALTO * 2;
         end;
      '(':
         begin
            xi := FUENTE_ANCHO * 12;
            yi := FUENTE_ALTO * 2;
         end;
      ')':
         begin
            xi := FUENTE_ANCHO * 13;
            yi := FUENTE_ALTO * 2;
         end;
      '[':
         begin
            xi := FUENTE_ANCHO * 14;
            yi := FUENTE_ALTO * 2;
         end;
      ']':
         begin
            xi := FUENTE_ANCHO * 15;
            yi := FUENTE_ALTO * 2;
         end;
      '{':
         begin
            xi := FUENTE_ANCHO * 16;
            yi := FUENTE_ALTO * 2;
         end;
      '}':
         begin
            xi := FUENTE_ANCHO * 17;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 18;
            yi := FUENTE_ALTO * 2;
         end;
      '!':
         begin
            xi := FUENTE_ANCHO * 19;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 20;
            yi := FUENTE_ALTO * 2;
         end;
      '?':
         begin
            xi := FUENTE_ANCHO * 21;
            yi := FUENTE_ALTO * 2;
         end;
      '"':
         begin
            xi := FUENTE_ANCHO * 22;
            yi := FUENTE_ALTO * 2;
         end;
      chr(39):
         begin
            xi := FUENTE_ANCHO * 23;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 24;
            yi := FUENTE_ALTO * 2;
         end;
      '`':
         begin
            xi := FUENTE_ANCHO * 25;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := FUENTE_ALTO * 2;
         end;
      '^':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := FUENTE_ALTO * 2;
         end;
      '~':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 29;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := 0;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 2;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 3;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 4;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 5;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 6;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 7;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 8;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 9;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 10;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 11;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 12;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 13;
            yi := FUENTE_ALTO * 3;
         end;
      ',':
         begin
            xi := FUENTE_ANCHO * 14;
            yi := FUENTE_ALTO * 3;
         end;
      ';':
         begin
            xi := FUENTE_ANCHO * 15;
            yi := FUENTE_ALTO * 3;
         end;
      '.':
         begin
            xi := FUENTE_ANCHO * 16;
            yi := FUENTE_ALTO * 3;
         end;
      ':':
         begin
            xi := FUENTE_ANCHO * 17;
            yi := FUENTE_ALTO * 3;
         end;
      '=':
         begin
            xi := FUENTE_ANCHO * 18;
            yi := FUENTE_ALTO * 3;
         end;
      '+':
         begin
            xi := FUENTE_ANCHO * 19;
            yi := FUENTE_ALTO * 3;
         end;
      '-':
         begin
            xi := FUENTE_ANCHO * 20;
            yi := FUENTE_ALTO * 3;
         end;
      '*':
         begin
            xi := FUENTE_ANCHO * 21;
            yi := FUENTE_ALTO * 3;
         end;
      '/':
         begin
            xi := FUENTE_ANCHO * 22;
            yi := FUENTE_ALTO * 3;
         end;
      '%':
         begin
            xi := FUENTE_ANCHO * 23;
            yi := FUENTE_ALTO * 3;
         end;
      '&':
         begin
            xi := FUENTE_ANCHO * 24;
            yi := FUENTE_ALTO * 3;
         end;
      '#':
         begin
            xi := FUENTE_ANCHO * 25;
            yi := FUENTE_ALTO * 3;
         end;
      '$':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := FUENTE_ALTO * 3;
         end;
      '_':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := FUENTE_ALTO * 3;
         end;
      '\':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := FUENTE_ALTO * 3;
         end;
      '|':
         begin
            xi := FUENTE_ANCHO * 29;
            yi := FUENTE_ALTO * 3;
         end;
   end;

   M13hImagenPegarMascara (x, y, FUENTE_ANCHO, FUENTE_ALTO, xi, yi, fuente.imagen, fuente.cclave, color);
end;
{--------------------------------------------------------------------------------}
procedure FuentePegarLetra2 (car: char; x, y: word; color: byte; fuente: tFuente);
var
   xi, yi: word;
begin
   case car of
      'A'..'Z':
         begin
            xi := FUENTE_ANCHO * (ord(car) - ord('A'));
            yi := 0;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := 0;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := 0;
         end;
      ' ':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := 0;
         end;
      'a'..'z':
         begin
            xi := FUENTE_ANCHO * (ord(car) - ord('a'));
            yi := FUENTE_ALTO;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := FUENTE_ALTO;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := FUENTE_ALTO;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := FUENTE_ALTO;
         end;
      '@':
         begin
            xi := FUENTE_ANCHO * 29;
            yi := FUENTE_ALTO;
         end;
      '0'..'9':
         begin
            xi := FUENTE_ANCHO * (ord(car) - ord('0'));
            yi := FUENTE_ALTO * 2;
         end;
      '<':
         begin
            xi := FUENTE_ANCHO * 10;
            yi := FUENTE_ALTO * 2;
         end;
      '>':
         begin
            xi := FUENTE_ANCHO * 11;
            yi := FUENTE_ALTO * 2;
         end;
      '(':
         begin
            xi := FUENTE_ANCHO * 12;
            yi := FUENTE_ALTO * 2;
         end;
      ')':
         begin
            xi := FUENTE_ANCHO * 13;
            yi := FUENTE_ALTO * 2;
         end;
      '[':
         begin
            xi := FUENTE_ANCHO * 14;
            yi := FUENTE_ALTO * 2;
         end;
      ']':
         begin
            xi := FUENTE_ANCHO * 15;
            yi := FUENTE_ALTO * 2;
         end;
      '{':
         begin
            xi := FUENTE_ANCHO * 16;
            yi := FUENTE_ALTO * 2;
         end;
      '}':
         begin
            xi := FUENTE_ANCHO * 17;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 18;
            yi := FUENTE_ALTO * 2;
         end;
      '!':
         begin
            xi := FUENTE_ANCHO * 19;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 20;
            yi := FUENTE_ALTO * 2;
         end;
      '?':
         begin
            xi := FUENTE_ANCHO * 21;
            yi := FUENTE_ALTO * 2;
         end;
      '"':
         begin
            xi := FUENTE_ANCHO * 22;
            yi := FUENTE_ALTO * 2;
         end;
      chr(39):
         begin
            xi := FUENTE_ANCHO * 23;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 24;
            yi := FUENTE_ALTO * 2;
         end;
      '`':
         begin
            xi := FUENTE_ANCHO * 25;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := FUENTE_ALTO * 2;
         end;
      '^':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := FUENTE_ALTO * 2;
         end;
      '~':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 29;
            yi := FUENTE_ALTO * 2;
         end;
      '':
         begin
            xi := 0;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 2;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 3;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 4;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 5;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 6;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 7;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 8;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 9;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 10;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 11;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 12;
            yi := FUENTE_ALTO * 3;
         end;
      '':
         begin
            xi := FUENTE_ANCHO * 13;
            yi := FUENTE_ALTO * 3;
         end;
      ',':
         begin
            xi := FUENTE_ANCHO * 14;
            yi := FUENTE_ALTO * 3;
         end;
      ';':
         begin
            xi := FUENTE_ANCHO * 15;
            yi := FUENTE_ALTO * 3;
         end;
      '.':
         begin
            xi := FUENTE_ANCHO * 16;
            yi := FUENTE_ALTO * 3;
         end;
      ':':
         begin
            xi := FUENTE_ANCHO * 17;
            yi := FUENTE_ALTO * 3;
         end;
      '=':
         begin
            xi := FUENTE_ANCHO * 18;
            yi := FUENTE_ALTO * 3;
         end;
      '+':
         begin
            xi := FUENTE_ANCHO * 19;
            yi := FUENTE_ALTO * 3;
         end;
      '-':
         begin
            xi := FUENTE_ANCHO * 20;
            yi := FUENTE_ALTO * 3;
         end;
      '*':
         begin
            xi := FUENTE_ANCHO * 21;
            yi := FUENTE_ALTO * 3;
         end;
      '/':
         begin
            xi := FUENTE_ANCHO * 22;
            yi := FUENTE_ALTO * 3;
         end;
      '%':
         begin
            xi := FUENTE_ANCHO * 23;
            yi := FUENTE_ALTO * 3;
         end;
      '&':
         begin
            xi := FUENTE_ANCHO * 24;
            yi := FUENTE_ALTO * 3;
         end;
      '#':
         begin
            xi := FUENTE_ANCHO * 25;
            yi := FUENTE_ALTO * 3;
         end;
      '$':
         begin
            xi := FUENTE_ANCHO * 26;
            yi := FUENTE_ALTO * 3;
         end;
      '_':
         begin
            xi := FUENTE_ANCHO * 27;
            yi := FUENTE_ALTO * 3;
         end;
      '\':
         begin
            xi := FUENTE_ANCHO * 28;
            yi := FUENTE_ALTO * 3;
         end;
      '|':
         begin
            xi := FUENTE_ANCHO * 29;
            yi := FUENTE_ALTO * 3;
         end;
   end;

   M13hImagenPegarMascara (x, y, FUENTE_ANCHO, FUENTE_ALTO, xi, yi, fuente.imagen, fuente.cclave, color);
end;
{--------------------------------------------------------------------------------}
procedure FuenteEscribir (cadena: string; x, y: word; color: byte; fuente: tFuente);
var
   i, tam: word;
begin
   tam := length(cadena);

   for i := 1 to tam do
    begin
      FuentePegarLetra(cadena[i], x + (FUENTE_ANCHO * (i - 1)), y, color, fuente);
    end;
end;
{--------------------------------------------------------------------------------}
procedure FuenteEscribir2 (cadena: string; x, y: word; color: byte; fuente: tFuente);
var
   i, tam: word;
begin
   tam := length(cadena);

   for i := 1 to tam do
    begin
      FuentePegarLetra2(cadena[i], x + (FUENTE_ANCHO * (i - 1)), y, color, fuente);
    end;
end;

{********************************************************************************}
end.
{********************************************************************************}